/** @file audiod.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.21
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef AUDIOD_CMDLINE_H
#define AUDIOD_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef AUDIOD_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define AUDIOD_CMDLINE_PARSER_PACKAGE "para_audiod"
#endif

#ifndef AUDIOD_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define AUDIOD_CMDLINE_PARSER_VERSION "0.3.0"
#endif

/** @brief Where the command line options are stored */
struct audiod_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * user_arg;	/**< @brief run as user 'name'. Read the output of
  'para_server -h' for more information on this
  option..  */
  char * user_orig;	/**< @brief run as user 'name'. Read the output of
  'para_server -h' for more information on this
  option. original value given at command line.  */
  const char *user_help; /**< @brief run as user 'name'. Read the output of
  'para_server -h' for more information on this
  option. help description.  */
  char * group_arg;	/**< @brief set group id to 'group'. Read the output of
  'para_server -h' for more information on this
  option..  */
  char * group_orig;	/**< @brief set group id to 'group'. Read the output of
  'para_server -h' for more information on this
  option. original value given at command line.  */
  const char *group_help; /**< @brief set group id to 'group'. Read the output of
  'para_server -h' for more information on this
  option. help description.  */
  int loglevel_arg;	/**< @brief set loglevel (0-6) (default='4').  */
  char * loglevel_orig;	/**< @brief set loglevel (0-6) original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel (0-6) help description.  */
  int daemon_flag;	/**< @brief run as background daemon (default=off).  */
  const char *daemon_help; /**< @brief run as background daemon help description.  */
  int force_flag;	/**< @brief force startup even if
  socket exists (default=off).  */
  const char *force_help; /**< @brief force startup even if
  socket exists help description.  */
  char * logfile_arg;	/**< @brief (default=stdout/stderr).  */
  char * logfile_orig;	/**< @brief (default=stdout/stderr) original value given at command line.  */
  const char *logfile_help; /**< @brief (default=stdout/stderr) help description.  */
  char * mode_arg;	/**< @brief mode to use on startup (on/off/sb) (default='on').  */
  char * mode_orig;	/**< @brief mode to use on startup (on/off/sb) original value given at command line.  */
  const char *mode_help; /**< @brief mode to use on startup (on/off/sb) help description.  */
  char * socket_arg;	/**< @brief well-known socket to listen on
  (default=/var/paraslash/audiod_sock.<host_name>).  */
  char * socket_orig;	/**< @brief well-known socket to listen on
  (default=/var/paraslash/audiod_sock.<host_name>) original value given at command line.  */
  const char *socket_help; /**< @brief well-known socket to listen on
  (default=/var/paraslash/audiod_sock.<host_name>) help description.  */
  int* user_allow_arg;	/**< @brief allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, all users are allowed to
  connect. (default='-1').  */
  char ** user_allow_orig;	/**< @brief allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, all users are allowed to
  connect. original value given at command line.  */
  int user_allow_min; /**< @brief allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, all users are allowed to
  connect.'s minimum occurreces */
  int user_allow_max; /**< @brief allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, all users are allowed to
  connect.'s maximum occurreces */
  const char *user_allow_help; /**< @brief allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, all users are allowed to
  connect. help description.  */
  int clock_diff_count_arg;	/**< @brief check the clock difference between
  server_host (the host running para_server)
  and the local host (running para_audiod)
  that many times before starting any stream
  I/0. Set this to non-zero for non-local
  setups if the clocks of these two hosts are
  not syncronized by ntp or similar. (default='0').  */
  char * clock_diff_count_orig;	/**< @brief check the clock difference between
  server_host (the host running para_server)
  and the local host (running para_audiod)
  that many times before starting any stream
  I/0. Set this to non-zero for non-local
  setups if the clocks of these two hosts are
  not syncronized by ntp or similar. original value given at command line.  */
  const char *clock_diff_count_help; /**< @brief check the clock difference between
  server_host (the host running para_server)
  and the local host (running para_audiod)
  that many times before starting any stream
  I/0. Set this to non-zero for non-local
  setups if the clocks of these two hosts are
  not syncronized by ntp or similar. help description.  */
  char ** receiver_arg;	/**< @brief Select receiver.  May be given multiple
  times, once for each supported audio format.
  'receiver_spec' consists of an audio format and
  the receiver name, separated by a colon, and
  any options for that receiver, seperated by
  whitespace.  If any receiver options are
  present, the whole receiver argument must be
  quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
 (default='http').  */
  char ** receiver_orig;	/**< @brief Select receiver.  May be given multiple
  times, once for each supported audio format.
  'receiver_spec' consists of an audio format and
  the receiver name, separated by a colon, and
  any options for that receiver, seperated by
  whitespace.  If any receiver options are
  present, the whole receiver argument must be
  quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
 original value given at command line.  */
  int receiver_min; /**< @brief Select receiver.  May be given multiple
  times, once for each supported audio format.
  'receiver_spec' consists of an audio format and
  the receiver name, separated by a colon, and
  any options for that receiver, seperated by
  whitespace.  If any receiver options are
  present, the whole receiver argument must be
  quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
's minimum occurreces */
  int receiver_max; /**< @brief Select receiver.  May be given multiple
  times, once for each supported audio format.
  'receiver_spec' consists of an audio format and
  the receiver name, separated by a colon, and
  any options for that receiver, seperated by
  whitespace.  If any receiver options are
  present, the whole receiver argument must be
  quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
's maximum occurreces */
  const char *receiver_help; /**< @brief Select receiver.  May be given multiple
  times, once for each supported audio format.
  'receiver_spec' consists of an audio format and
  the receiver name, separated by a colon, and
  any options for that receiver, seperated by
  whitespace.  If any receiver options are
  present, the whole receiver argument must be
  quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
 help description.  */
  int no_default_filters_flag;	/**< @brief Configure filters manually. If (and only
  if) this option is set, the --filter options
  take effect.  Otherwise, the compiled-in
  default filters mp3dec, oggdec and aacdec are
  activated for mp3, ogg, aac streams respectively. (default=off).  */
  const char *no_default_filters_help; /**< @brief Configure filters manually. If (and only
  if) this option is set, the --filter options
  take effect.  Otherwise, the compiled-in
  default filters mp3dec, oggdec and aacdec are
  activated for mp3, ogg, aac streams respectively. help description.  */
  char ** filter_arg;	/**< @brief Select filter(s) manually.  May be given
  multiple times. filter_spec consists of an
  audio format, the name of the filter, and any
  options for that filter.
  
  Examples:
  	-f 'mp3:mp3dec'
  	-f 'mp3:compress --inertia 5 --damp 2'
  
  Note that these options are ignored by default,
  see --no_default_filters..  */
  char ** filter_orig;	/**< @brief Select filter(s) manually.  May be given
  multiple times. filter_spec consists of an
  audio format, the name of the filter, and any
  options for that filter.
  
  Examples:
  	-f 'mp3:mp3dec'
  	-f 'mp3:compress --inertia 5 --damp 2'
  
  Note that these options are ignored by default,
  see --no_default_filters. original value given at command line.  */
  int filter_min; /**< @brief Select filter(s) manually.  May be given
  multiple times. filter_spec consists of an
  audio format, the name of the filter, and any
  options for that filter.
  
  Examples:
  	-f 'mp3:mp3dec'
  	-f 'mp3:compress --inertia 5 --damp 2'
  
  Note that these options are ignored by default,
  see --no_default_filters.'s minimum occurreces */
  int filter_max; /**< @brief Select filter(s) manually.  May be given
  multiple times. filter_spec consists of an
  audio format, the name of the filter, and any
  options for that filter.
  
  Examples:
  	-f 'mp3:mp3dec'
  	-f 'mp3:compress --inertia 5 --damp 2'
  
  Note that these options are ignored by default,
  see --no_default_filters.'s maximum occurreces */
  const char *filter_help; /**< @brief Select filter(s) manually.  May be given
  multiple times. filter_spec consists of an
  audio format, the name of the filter, and any
  options for that filter.
  
  Examples:
  	-f 'mp3:mp3dec'
  	-f 'mp3:compress --inertia 5 --damp 2'
  
  Note that these options are ignored by default,
  see --no_default_filters. help description.  */
  char ** writer_arg;	/**< @brief Specify stream writer.
  
  May be given multiple times, even multiple
  times for the same audio format.  Default
  value is 'alsa' for all supported audio
  formats. Example:
  
  	-w 'aac:osx'
  
.  */
  char ** writer_orig;	/**< @brief Specify stream writer.
  
  May be given multiple times, even multiple
  times for the same audio format.  Default
  value is 'alsa' for all supported audio
  formats. Example:
  
  	-w 'aac:osx'
  
 original value given at command line.  */
  int writer_min; /**< @brief Specify stream writer.
  
  May be given multiple times, even multiple
  times for the same audio format.  Default
  value is 'alsa' for all supported audio
  formats. Example:
  
  	-w 'aac:osx'
  
's minimum occurreces */
  int writer_max; /**< @brief Specify stream writer.
  
  May be given multiple times, even multiple
  times for the same audio format.  Default
  value is 'alsa' for all supported audio
  formats. Example:
  
  	-w 'aac:osx'
  
's maximum occurreces */
  const char *writer_help; /**< @brief Specify stream writer.
  
  May be given multiple times, even multiple
  times for the same audio format.  Default
  value is 'alsa' for all supported audio
  formats. Example:
  
  	-w 'aac:osx'
  
 help description.  */
  int stream_delay_arg;	/**< @brief Time to add to para_server's start_time.
  
  Amount of time to be added to the server, before data is sent to
  the writer.  Useful for syncronizing the audio output of clients. (default='200').  */
  char * stream_delay_orig;	/**< @brief Time to add to para_server's start_time.
  
  Amount of time to be added to the server, before data is sent to
  the writer.  Useful for syncronizing the audio output of clients. original value given at command line.  */
  const char *stream_delay_help; /**< @brief Time to add to para_server's start_time.
  
  Amount of time to be added to the server, before data is sent to
  the writer.  Useful for syncronizing the audio output of clients. help description.  */
  int stream_timeout_arg;	/**< @brief Deactivate slot if idle for that many
  seconds (default='30').  */
  char * stream_timeout_orig;	/**< @brief Deactivate slot if idle for that many
  seconds original value given at command line.  */
  const char *stream_timeout_help; /**< @brief Deactivate slot if idle for that many
  seconds help description.  */
  
  int help_given ;	/**< @brief Whether help was given.  */
  int version_given ;	/**< @brief Whether version was given.  */
  int user_given ;	/**< @brief Whether user was given.  */
  int group_given ;	/**< @brief Whether group was given.  */
  int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  int daemon_given ;	/**< @brief Whether daemon was given.  */
  int force_given ;	/**< @brief Whether force was given.  */
  int logfile_given ;	/**< @brief Whether logfile was given.  */
  int mode_given ;	/**< @brief Whether mode was given.  */
  int socket_given ;	/**< @brief Whether socket was given.  */
  unsigned int user_allow_given ;	/**< @brief Whether user_allow was given.  */
  int clock_diff_count_given ;	/**< @brief Whether clock_diff_count was given.  */
  unsigned int receiver_given ;	/**< @brief Whether receiver was given.  */
  int no_default_filters_given ;	/**< @brief Whether no_default_filters was given.  */
  unsigned int filter_given ;	/**< @brief Whether filter was given.  */
  unsigned int writer_given ;	/**< @brief Whether writer was given.  */
  int stream_delay_given ;	/**< @brief Whether stream_delay was given.  */
  int stream_timeout_given ;	/**< @brief Whether stream_timeout was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct audiod_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure audiod_args_info (default 0) */
  int check_required; /**< @brief whether to check that all required options were provided (default 0) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure audiod_args_info (default 0) */
} ;

/** @brief the purpose string of the program */
extern const char *audiod_args_info_purpose;
/** @brief the usage string of the program */
extern const char *audiod_args_info_usage;
/** @brief all the lines making the help output */
extern const char *audiod_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audiod_cmdline_parser (int argc, char * const *argv,
  struct audiod_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use audiod_cmdline_parser_ext() instead
 */
int audiod_cmdline_parser2 (int argc, char * const *argv,
  struct audiod_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audiod_cmdline_parser_ext (int argc, char * const *argv,
  struct audiod_args_info *args_info,
  struct audiod_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audiod_cmdline_parser_file_save(const char *filename,
  struct audiod_args_info *args_info);

/**
 * Print the help
 */
void audiod_cmdline_parser_print_help(void);
/**
 * Print the version
 */
void audiod_cmdline_parser_print_version(void);

/**
 * Allocates dynamically a audiod_cmdline_parser_params structure and initializes
 * all its fields to 0
 * @return the initialized audiod_cmdline_parser_params structure
 */
struct audiod_cmdline_parser_params *audiod_cmdline_parser_params_init(void);

/**
 * Initializes the passed audiod_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void audiod_cmdline_parser_init (struct audiod_args_info *args_info);
/**
 * Deallocates the string fields of the audiod_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void audiod_cmdline_parser_free (struct audiod_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use audiod_cmdline_parser_config_file() instead
 */
int audiod_cmdline_parser_configfile (char * const filename,
  struct audiod_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audiod_cmdline_parser_config_file (char * const filename,
  struct audiod_args_info *args_info,
  struct audiod_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int audiod_cmdline_parser_required (struct audiod_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* AUDIOD_CMDLINE_H */
